]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
- add ruby_rdocdir
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
1d7abbe3 1#!/bin/ksh
44058243 2#
dece74ed
AM
3# This program is free software, distributed under the terms of
4# the GNU General Public License Version 2.
5#
cd445739 6# -----------
cd445739 7# Exit codes:
2a5f078d 8# 0 - succesful
9# 1 - help displayed
10# 2 - no spec file name in cmdl parameters
11# 3 - spec file not stored in repo
12# 4 - some source, patch or icon files not stored in repo
13# 5 - package build failed
14# 6 - spec file with errors
15# 7 - wrong source in /etc/poldek.conf
16# 8 - Failed installing buildrequirements and subrequirements
17# 9 - Requested tag already exist
18# 10 - Refused to build fractional release
19# 100 - Unknown error (should not happen)
cd445739 20
f8e50be5
ER
21# Notes (todo/bugs):
22# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
23# - when Icon: field is present, -5 and -a5 doesn't work
24# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
25# TODO:
26# - ability to do ./builder -bb foo.spec foo2.spec foo3.spec
931a4acf 27
d43959a2
ER
28RCSID='$Id$'
29r=${RCSID#* * }
30rev=${r%% *}
99b2e827 31VERSION="v0.23/$rev"
d43959a2 32VERSIONSTRING="\
c9acaed9 33Build package utility from PLD Linux CVS repository
4062d64a 34$VERSION (C) 1999-2008 Free Penguins".
d43959a2 35
d6a77ddb 36PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 37
cd445739 38COMMAND="build"
64ea5308 39TARGET=""
cd445739 40
bde1c404 41SPECFILE=""
d287305c 42BE_VERBOSE=""
4003ad8c 43QUIET=""
cd445739
AM
44CLEAN=""
45DEBUG=""
46NOURLS=""
47NOCVS=""
48NOCVSSPEC=""
49NODIST=""
47761337 50NOINIT=""
bc10f694 51PREFMIRRORS=""
cd445739 52UPDATE=""
cd445739
AM
53ADD5=""
54NO5=""
55ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 56CVSROOT=""
cdbd30e8 57GREEDSRC=""
cd445739 58
6c1b2e7d
PZ
59# use rpm 4.4.6+ digest format instead of comments if non-zero
60USEDIGEST=
61
e3aa6f5e
ER
62# user agent when fetching files
63USER_AGENT="PLD/Builder($VERSION)"
64
cd445739
AM
65# It can be used i.e. in log file naming.
66# See LOGFILE example.
67DATE=`date +%Y-%m-%d_%H-%M-%S`
68
69# Example: LOGFILE='../log.$PACKAGE_NAME'
70# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
71# Yes, you can use variable name! Note _single_ quotes!
72LOGFILE=''
73
74LOGDIR=""
75LOGDIROK=""
76LOGDIRFAIL=""
77LASTLOG_FILE=""
78
79CHMOD="no"
1da227e8 80CHMOD_MODE="0644"
cd445739 81RPMOPTS=""
d1c5a9a7 82RPMBUILDOPTS=""
cd445739
AM
83BCOND=""
84GROUP_BCONDS="no"
947025e5 85CVSIGNORE_DF="no"
d287305c 86
87PATCHES=""
88SOURCES=""
cd445739 89ICONS=""
d287305c 90PACKAGE_RELEASE=""
91PACKAGE_VERSION=""
92PACKAGE_NAME=""
14bead22 93ASSUMED_NAME=""
cd445739
AM
94PROTOCOL="ftp"
95WGET_RETRIES=${MAX_WGET_RETRIES:-0}
96CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
97
98CVSTAG=""
99RES_FILE=""
39dcc7de 100CVS_FORCE=""
cd445739
AM
101
102CVS_SERVER="cvs.pld-linux.org"
103DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 104ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 105
36d03934 106DEF_NICE_LEVEL=19
86aafdbe 107SCHEDTOOL="auto"
cd445739
AM
108
109FAIL_IF_NO_SOURCES="yes"
110
18e5347d
ER
111# let get_files skip over files which are present to get those damn files fetched
112SKIP_EXISTING_FILES="no"
113
975d7b23 114TRY_UPGRADE=""
257af81b
ER
115# should the specfile be restored if upgrade failed?
116REVERT_BROKEN_UPGRADE="yes"
117
90baf90b
ER
118if rpm --specsrpm 2>/dev/null; then
119 FETCH_BUILD_REQUIRES_RPMSPECSRPM="yes"
ce40491a 120 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
90baf90b
ER
121else
122 FETCH_BUILD_REQUIRES_RPMSPECSRPM="no"
123 if [ -x /usr/bin/rpm-getdeps ]; then
124 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
125 else
126 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
127 fi
ab4a2b6e
ER
128fi
129
90baf90b 130
cd445739
AM
131# Here we load saved user environment used to
132# predefine options set above, or passed to builder
133# in command line.
134# This one reads global system environment settings:
135if [ -f ~/etc/builderrc ]; then
136 . ~/etc/builderrc
137fi
138# And this one cascades settings using user personal
139# builder settings.
140# Example of ~/.builderrc:
141#
142#UPDATE_POLDEK_INDEXES="yes"
143#FETCH_BUILD_REQUIRES="yes"
144#REMOVE_BUILD_REQUIRES="force"
145#GROUP_BCONDS="yes"
146#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
982e358c 147#TITLECHANGE=no
cd445739 148#
a83e5405 149SU_SUDO=""
cd445739
AM
150if [ -n "$HOME_ETC" ]; then
151 USER_CFG="$HOME_ETC/.builderrc"
20117088 152 BUILDER_MACROS="$HOME_ETC/.builder-rpmmacros"
cd445739
AM
153else
154 USER_CFG=~/.builderrc
20117088 155 BUILDER_MACROS=~/.builder-rpmmacros
cd445739
AM
156fi
157
158[ -f "$USER_CFG" ] && . "$USER_CFG"
159
86aafdbe
ER
160if [ "$SCHEDTOOL" = "auto" ]; then
161 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
162 SCHEDTOOL="schedtool -B -e"
163 else
164 SCHEDTOOL="no"
165 fi
166fi
167
ca2e6c31 168if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
169 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
170 GETURI2="$GETURI"
171 OUTFILEOPT="-O"
ca2e6c31 172elif [ -n "$USE_AXEL" ]; then
cede92b3 173 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
174 GETURI2="$GETURI"
175 OUTFILEOPT="-o"
ca2e6c31 176else
5700ee32
ER
177 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
178 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
179 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
e3aa6f5e 180 WGET_OPTS="$WGET_OPTS --user-agent=$USER_AGENT"
6f9a5d76 181
7e365483
KK
182 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
183 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
184 OUTFILEOPT="-O"
2bc5451f 185fi
11468b23 186
11468b23
AM
187GETLOCAL="cp -a"
188
189if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
190 RPM="rpm"
191 RPMBUILD="rpm"
192else
193 RPM="rpm"
194 RPMBUILD="rpmbuild"
195fi
196
28c23a72
AG
197#
198# are we using cvs-nserver ?
199#
e21039da
AG
200CVS_NSERVER=0
201cvs --version 2>&1 | grep -q 'CVS-nserver'
202[ $? -eq 0 ] && CVS_NSERVER=1
28c23a72 203
a8c9a155 204POLDEK_INDEX_DIR="$($RPM --eval %_rpmdir)/"
a83e5405 205POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 206
cd445739
AM
207run_poldek()
208{
525bf240 209 RES_FILE=$(mktemp -t builder.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM)
cd445739
AM
210 if [ -n "$LOGFILE" ]; then
211 LOG=`eval echo $LOGFILE`
212 if [ -n "$LASTLOG_FILE" ]; then
213 echo "LASTLOG=$LOG" > $LASTLOG_FILE
214 fi
86aafdbe 215 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
216 return $exit_pldk
217 else
86aafdbe 218 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
cd445739
AM
219 return `cat ${RES_FILE}`
220 rm -rf ${RES_FILE}
221 fi
222}
223
cd445739
AM
224#---------------------------------------------
225# functions
da946cd6 226
5a491465 227usage()
228{
cd445739
AM
229 if [ -n "$DEBUG" ]; then set -xv; fi
230 echo "\
d43959a2 231Usage: builder [-D|--debug] [-V|--version] [--short-version] [-a|--as_anon] [-b|-ba|--build]
6594293d 232[-bb|--build-binary] [-bs|--build-source] [-bc] [-bi] [-bl] [-u|--try-upgrade]
4efa0b98 233[{-cf|--cvs-force}] [{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>]
19dc5591 234[-g|--get] [-h|--help] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
235[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T|--tag <cvstag>]
a7b2951c 236[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
f8dba812 237[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}] [--use-greed-sources]
6594293d 238[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
3009b80d 239[--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
6594293d 240<package>[.spec][:cvstag]
2a5f078d 241
cd445739
AM
242-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
243-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
244-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
245-D, --debug - enable builder script debugging mode,
246-debug - produce rpm debug package (same as --opts -debug)
d43959a2
ER
247-V, --version - output builder version string
248--short-version - output builder short version
cd445739
AM
249-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
250-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
251 from <package>.spec,
252-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
253 only package from <package>.spec,
c56807e0 254-bp, --build-prep - execute the %prep phase of <package>.spec,
6594293d
AG
255-bc - execute the %build phase of <package>.spec,
256-bi - execute the %install phase of <package>.spec
257-bl - execute the %files phase of <package>.spec
cd445739
AM
258-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
259 them into src.rpm,
6594293d 260--short-circuit - short-circuit build
cd445739
AM
261-B, --branch - add branch
262-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
6f10b394
ER
263 SPECS and \$RPM_BUILD_ROOT and CVS/Entries) after rpmbuild commands.
264-m, --mr-proper - clean all temporarily created files (in BUILD, SOURCES,
265 SPECS and \$RPM_BUILD_ROOT and CVS/Entries). Doesn't run
266 any rpm building.
39dcc7de 267-cf, --cvs-force - use -F when tagging (useful when moving branches)
2a5f078d 268-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
269 - setup \$CVSROOT,
270--define <macro> <value>
271 - define a macro <macro> with value <value>,
44058243
ER
272--alt_kernel <kernel>
273 - same as --define 'alt_kernel <kernel>'
cd445739
AM
274--nodeps - rpm won't check any dependences
275-g, --get - get <package>.spec and all related files from CVS repo
276 or HTTP/FTP,
277-h, --help - this message,
278--http - use http instead of ftp,
279-l <logfile>, --logtofile <logfile>
280 - log all to file,
cd445739
AM
281-nc, --no-cvs - don't download sources from CVS, if source URL is given,
282-ncs, --no-cvs-specs
283 - don't check specs in CVS
284-nd, --no-distfiles - don't download from distfiles
285-nm, --no-mirrors - don't download from mirror, if source URL is given,
286-nu, --no-urls - don't try to download from FTP/HTTP location,
287-ns, --no-srcs - don't download Sources
288-ns0, --no-source0 - don't download Source0
289-nn, --no-net - don't download anything from the net
a93e8cdf 290-pm, --prefer-mirrors - prefer mirrors (if any) over distfiles for SOURCES
b572253e 291--no-init - don't initialize builder paths (SPECS and SOURCES)
18e5347d
ER
292-ske,
293--skip-existing-files - skip existing files in get_files
cd445739
AM
294--opts <rpm opts> - additional options for rpm
295-q, --quiet - be quiet,
296--date yyyy-mm-dd - build package using resources from specified CVS date,
297-r <cvstag>, --cvstag <cvstag>
298 - build package using resources from specified CVS tag,
5323fffd 299-A - build package using CVS resources as any sticky tags/date/kopts being reset.
cd445739
AM
300-R, --fetch-build-requires
301 - fetch what is BuildRequired,
302-RB, --remove-build-requires
303 - remove all you fetched with -R or --fetch-build-requires
304 remember, this option requires confirmation,
305-FRB, --force-remove-build-requires
306 - remove all you fetched with -R or --fetch-build-requires
307 remember, this option works without confirmation,
06541433
JR
308-sd, --source-distfiles - list sources available from distfiles (intended for offline
309 operations; does not work when Icon field is present
310 but icon file is absent),
e15852ab 311-sc, --source-cvs - list sources available from CVS
06541433
JR
312-sdp, --source-distfiles-paths - list sources available from distfiles -
313 paths relative to distfiles directory (intended for offline
314 operations; does not work when Icon field is present
315 but icon file is absent),
a7eefc54 316-sf, --source-files - list sources - bare filenames (intended for offline
317 operations; does not work when Icon field is present
3621e588 318 but icon file is absent),
a7eefc54 319-sp, --source-paths - list sources - filenames with full local paths (intended for
320 offline operations; does not work when Icon field is present
3621e588 321 but icon file is absent),
2dddf439
ER
322-su, --source-urls - list urls - urls to sources and patches
323 intended for copying urls with spec with lots of macros in urls
cd445739
AM
324-T <cvstag> , --tag <cvstag>
325 - add cvs tag <cvstag> for files,
326-Tvs, --tag-version-stable
094bd95b 327 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739
AM
328-Ts, --tag-stable
329 - add cvs tag STABLE for files,
cd445739 330-Tv, --tag-version
1691a37b 331 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
332-Tp, --tag-prefix <prefix>
333 - add <prefix> to NAME-VERSION-RELEASE tags,
334-tt, --test-tag <prefix>
335 - fail if tag is already present,
50321881
JK
336-ir, --integer-release-only
337 - allow only integer and snapshot releases
cd445739
AM
338-v, --verbose - be verbose,
339-u, --try-upgrade - check version, and try to upgrade package
340-un, --try-upgrade-with-float-version
341 - as above, but allow float version
f8dba812 342--use-greed-sources
343 - try download source from tag head if don't find it in
f5141bbc 344 current tag
deccc50e 345-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
346-Upi, --update-poldek-indexes
347 - refresh or make poldek package index files.
c890b916 348-np, --nopatch <patchnumber>
bed98670 349 - don't apply <patchnumber>
dfe2cb9a
MK
350--show-bconds - show available conditional builds, which can be used
351 - with --with and/or --without switches.
9b78be50
ER
352--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by
353 ./repackage.sh script. in other words, the output is
354 parseable by scripts.
cd445739
AM
355--with/--without <feature>
356 - conditional build package depending on %_with_<feature>/
357 %_without_<feature> macro switch. You may now use
358 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
359 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 360--target <platform>, --target=<platform>
3621e588
ER
361 - build for platform <platform>.
362--init-rpm-dir - initialize ~/rpm directory structure
5a491465 363"
364}
365
31d2bd0b
ER
366# change dependency to specname
367# common changes:
368# - perl(Package::Name) -> perl-Package-Name
369depspecname() {
370 local package="$1"
371
372 package=$(echo "$package" | sed -e '/perl(.*)/{s,perl(\(.*\)),perl-\1,;s,::,-,g}')
373 echo "$package"
374}
375
c890b916 376update_shell_title() {
a0d6396b 377 [ -t 1 ] || return
0b65d15e
ER
378 local len=${COLUMNS:-80}
379 local msg=$(echo "$*" | cut -c-$len)
380
e225de91
ER
381 if [ -n "$BE_VERBOSE" ]; then
382 echo >&2 "$(date +%s.%N) $*"
383 fi
384
982e358c 385 if [ "x$TITLECHANGE" == "xyes" -o "x$TITLECHANGE" == "x" ]; then
138bbc98
ER
386 local pkg
387 if [ -n "$PACKAGE_NAME" ]; then
388 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
389 else
390 pkg=${SPECFILE}
391 fi
392
393 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
a8c9a155 394 msg=$(echo $msg | tr -d '\n\r')
982e358c
MP
395 case "$TERM" in
396 cygwin|xterm*)
397 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
398 ;;
399 screen*)
400 echo >&2 -ne "\033]0;$msg\007"
401 ;;
402 esac
403 fi
c890b916
ER
404}
405
7e40520f
ER
406# set TARGET from BuildArch: from SPECFILE
407set_spec_target() {
ce40491a
ER
408 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
409 tmp=$(awk '/^BuildArch:/ { print $NF}' $SPECFILE)
410 if [ "$tmp" ]; then
f9109a96 411 target_platform=$(rpm -E '%{_target_vendor}-%{_target_os}%{?_gnu}')
7e40520f
ER
412 TARGET="$tmp"
413 case "$RPMBUILD" in
414 "rpmbuild")
f9109a96 415 TARGET_SWITCH="--target ${TARGET}-${target_platform}" ;;
7e40520f 416 "rpm")
ce40491a 417 TARGET_SWITCH="--target=$TARGET" ;;
7e40520f 418 esac
ce40491a
ER
419 fi
420 fi
7e40520f
ER
421}
422
ace3fd80
ER
423# runs rpm with minimal macroset
424minirpm() {
fa4bf1df 425 # we reset macros not to contain macros.build as all the %() macros are
559d511f 426 # executed here, while none of them are actually needed.
559d511f 427 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
525bf240 428 safe_macrofiles=$(rpm $TARGET_SWITCH --showrc | awk -F: '/^macrofiles/ { gsub(/^macrofiles[ \t]+:/, "", $0); gsub(/:.*macros.build:/, ":", $0); print $0 } ')
ace3fd80
ER
429
430 # TODO: move these to /usr/lib/rpm/macros
20117088 431 cat > $BUILDER_MACROS <<'EOF'
5b5e5f7f 432%x8664 x86_64 amd64 ia32e
f78a0bb7 433%alt_kernel %{nil}
434%_alt_kernel %{nil}
fb198857
ER
435%requires_releq_kernel_up %{nil}
436%requires_releq_kernel_smp %{nil}
1b2bbc99 437%requires_releq_kernel %{nil}
6b8134e3 438%requires_releq() %{nil}
bb01dee9 439%pyrequires_eq() %{nil}
559d511f 440%requires_eq() %{nil}
c13be3d1 441%requires_eq_to() %{nil}
fb198857
ER
442%releq_kernel_up ERROR
443%releq_kernel_smp ERROR
1b2bbc99 444%releq_kernel ERROR
74d9fd14 445%kgcc_package ERROR
237bd3f1 446%_fontsdir ERROR
7141278d 447%ruby_version ERROR
448%ruby_ver_requires_eq() %{nil}
449%ruby_mod_ver_requires_eq() %{nil}
c13be3d1 450%__php_api_requires() %{nil}
7141278d 451%php_major_version ERROR
452%php_api_version ERROR
99f819cf
AM
453%requires_xorg_xserver_extension %{nil}
454%requires_xorg_xserver_xinput %{nil}
455%requires_xorg_xserver_font %{nil}
456%requires_xorg_xserver_videodrv %{nil}
7141278d 457%py_ver ERROR
41035426
ER
458%perl_vendorarch ERROR
459%perl_vendorlib ERROR
703ae20b
ER
460# damn. need it here! - copied from /usr/lib/rpm/macros.build
461%tmpdir %(echo "${TMPDIR:-/tmp}")
1f28fcb7
ER
462%patchset_source(f:b:) %(
463 base=%{-b*}%{!-b*:10000};
464 start=$(expr $base + %1);
465 end=$(expr $base + %{?2}%{!?2:%{1}});
466 # we need to call seq twice as it doesn't allow two formats
467 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
468 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
469 paste %{tmpdir}/__ps{1,2};
470 rm -f %{tmpdir}/__ps{1,2};
471) \
472%{nil}
991f09a5
ER
473%add_etc_shells(p) %{p:<lua>}
474%remove_etc_shells(p) %{p:<lua>}
709995c4
ER
475%lua_add_etc_shells() %{nil}
476%lua_remove_etc_shells() %{nil}
fb198857 477EOF
3d12d055 478 if [ "$NOINIT" = "yes" ] ; then
20117088 479 cat >> $BUILDER_MACROS <<'EOF'
3d12d055
JR
480%_specdir ./
481%_sourcedir ./
482EOF
c039643c 483 fi
fff1b991 484 eval $RPMBUILD $TARGET_SWITCH --macros "$safe_macrofiles:$BUILDER_MACROS" $QUIET $RPMOPTS $RPMBUILDOPTS $BCOND $* 2>&1
ace3fd80
ER
485}
486
487cache_rpm_dump() {
488 if [ -n "$DEBUG" ]; then
489 set -x
490 set -v
491 fi
492
d1d24c14 493 if [ -x /usr/bin/rpm-specdump ]; then
525bf240 494 update_shell_title "cache_rpm_dump using rpm-specdump command"
fff1b991 495 rpm_dump_cache=$(rpm-specdump $TARGET_SWITCH $BCOND $SPECFILE)
d1d24c14 496 else
525bf240 497 update_shell_title "cache_rpm_dump using rpmbuild command"
d1d24c14
ER
498 local rpm_dump
499 rpm_dump=`
500 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
501 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
502 case "$RPMBUILD" in
503 rpm)
504 ARGS='-bp'
505 ;;
506 rpmbuild)
507 ARGS='--nodigest --nosignature --nobuild'
508 ;;
509 esac
510 minirpm $ARGS --define "'prep $dump'" --nodeps $SPECFILE
511 `
512 if [ $? -gt 0 ]; then
513 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
514 echo "$error" >&2
515 Exit_error err_build_fail
516 fi
d05e8080 517
d1d24c14
ER
518 # make small dump cache
519 rpm_dump_cache=`echo "$rpm_dump" | awk '
520 $2 ~ /^SOURCEURL/ {print}
521 $2 ~ /^PATCHURL/ {print}
522 $2 ~ /^nosource/ {print}
523 $2 ~ /^PACKAGE_/ {print}
524 '`
525 fi
d05e8080 526
13974367 527 update_shell_title "cache_rpm_dump: OK!"
cd445739
AM
528}
529
ace3fd80 530rpm_dump() {
cd445739 531 if [ -z "$rpm_dump_cache" ] ; then
45e2a818 532 echo >&2 "internal error: cache_rpm_dump not called! (missing %prep?)"
cd445739
AM
533 fi
534 echo "$rpm_dump_cache"
535}
536
d05e8080
ER
537get_icons()
538{
539 update_shell_title "get icons"
a8c9a155 540 ICONS=$(awk '/^Icon:/ {print $2}' ${SPECFILE})
d05e8080
ER
541 if [ -z "$ICONS" ]; then
542 return
543 fi
544
975d7b23 545 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
d05e8080
ER
546}
547
59398507 548parse_spec()
549{
af4d5315 550 update_shell_title "parsing specfile"
cd445739 551 if [ -n "$DEBUG" ]; then
518ff1fb
ER
552 set -x
553 set -v
cd445739 554 fi
b2975fc3 555
d05e8080 556 # icons are needed for successful spec parse
518ff1fb 557 get_icons
d05e8080 558
01fa66fc 559 cd $SPEC_DIR
cd445739 560 cache_rpm_dump
00fcec7e 561
cd445739 562 if [ "$NOSRCS" != "yes" ]; then
7823aac3 563 SOURCES=$(rpm_dump | awk '$2 ~ /^SOURCEURL[0-9]+/ {print substr($2, length("SOURCEURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
cd445739 564 fi
7cb24972 565
cd445739
AM
566 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
567 FAIL_IF_NO_SOURCES="no"
568 fi
569
7823aac3 570 PATCHES=$(rpm_dump | awk '$2 ~ /^PATCHURL[0-9]+/ {print substr($2, length("PATCHURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
a8c9a155 571 ICONS=$(awk '/^Icon:/ {print $2}' ${SPECFILE})
dfe2b2d9
ER
572 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3; exit}')
573 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3; exit}')
574 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3; exit}')
78eab2a1 575
0b4119a2 576 if [ "$PACKAGE_NAME" != "$ASSUMED_NAME" ]; then
7854d40c 577 echo >&2 "WARNING! Spec name ($ASSUMED_NAME) does not agree with package name ($PACKAGE_NAME)"
0b4119a2
JR
578 fi
579
cd445739
AM
580 if [ -n "$BE_VERBOSE" ]; then
581 echo "- Sources : `nourl $SOURCES`"
582 if [ -n "$PATCHES" ]; then
583 echo "- Patches : `nourl $PATCHES`"
584 else
585 echo "- Patches : *no patches needed*"
586 fi
587 if [ -n "$ICONS" ]; then
588 echo "- Icon : `nourl $ICONS`"
589 else
590 echo "- Icon : *no package icon*"
591 fi
592 echo "- Name : $PACKAGE_NAME"
593 echo "- Version : $PACKAGE_VERSION"
594 echo "- Release : $PACKAGE_RELEASE"
595 fi
13974367
ER
596
597 update_shell_title "parse_spec: OK!"
cd445739
AM
598}
599
600Exit_error()
601{
602 if [ -n "$DEBUG" ]; then
518ff1fb
ER
603 set -x
604 set -v
cd445739
AM
605 fi
606
607 cd "$__PWD"
608
609 case "$1" in
610 "err_no_spec_in_cmdl" )
611 remove_build_requires
45e2a818 612 echo >&2 "ERROR: spec file name not specified."
cd445739 613 exit 2 ;;
a08d92fc 614 "err_invalid_cmdline" )
45e2a818 615 echo >&2 "ERROR: invalid command line arg ($2)."
a08d92fc 616 exit 2 ;;
cd445739
AM
617 "err_no_spec_in_repo" )
618 remove_build_requires
45e2a818 619 echo >&2 "Error: spec file not stored in CVS repo."
cd445739
AM
620 exit 3 ;;
621 "err_no_source_in_repo" )
622 remove_build_requires
45e2a818 623 echo >&2 "Error: some source, patch or icon files not stored in CVS repo. ($2)"
cd445739
AM
624 exit 4 ;;
625 "err_build_fail" )
626 remove_build_requires
45e2a818 627 echo >&2 "Error: package build failed. (${2:-no more info})"
cd445739 628 exit 5 ;;
78eab2a1
AM
629 "err_no_package_data" )
630 remove_build_requires
45e2a818 631 echo >&2 "Error: couldn't get out package name/version/release from spec file."
78eab2a1 632 exit 6 ;;
ce40491a 633 "err_tag_exists" )
50321881 634 remove_build_requires
45e2a818 635 echo >&2 "Tag ${2} already exists (spec release: ${3})."
50321881 636 exit 9 ;;
ce40491a 637 "err_fract_rel" )
50321881 638 remove_build_requires
45e2a818 639 echo >&2 "Release ${2} not integer and not a snapshot."
50321881 640 exit 10 ;;
fb96e0b5
AM
641 "err_branch_exists" )
642 remove_build_requires
45e2a818 643 echo >&2 "Tree branch already exists (${2})."
fb96e0b5 644 exit 11 ;;
cfc497c0
ER
645 "err_acl_deny" )
646 remove_build_requires
45e2a818 647 echo >&2 "Error: conditions reject building this spec (${2})."
cfc497c0 648 exit 12 ;;
cd445739 649 esac
45e2a818 650 echo >&2 "Unknown error."
73848362 651 exit 100
cd445739
AM
652}
653
654init_builder()
655{
656 if [ -n "$DEBUG" ]; then
518ff1fb
ER
657 set -x
658 set -v
0dd6320d 659 fi
cd445739 660
4aeb9973 661 if [ "$NOINIT" != "yes" ] ; then
a08cc47e
ER
662 local extra
663 if [ "$ASSUMED_NAME" ]; then
664 extra="--define 'name $ASSUMED_NAME'"
665 fi
a8c9a155
ER
666 SOURCE_DIR=$(eval $RPM $RPMOPTS $extra --eval '%{_sourcedir}')
667 SPEC_DIR=$(eval $RPM $RPMOPTS $extra --eval '%{_specdir}')
29e90b02
JR
668 else
669 SOURCE_DIR="."
01fa66fc 670 SPEC_DIR="."
29e90b02 671 fi
cd445739 672
a8c9a155 673 __PWD=$(pwd)
00fcec7e 674}
675
d6a77ddb 676get_spec()
1471f6d6 677{
c890b916 678
2e5be021 679 update_shell_title "get_spec"
c890b916 680
cd445739 681 if [ -n "$DEBUG" ]; then
518ff1fb
ER
682 set -x
683 set -v
cd445739
AM
684 fi
685
01fa66fc 686 cd "$SPEC_DIR"
049ab214 687 if [ ! -f "$SPECFILE" ]; then
a8c9a155 688 SPECFILE="$(basename $SPECFILE .spec).spec"
cd445739
AM
689 fi
690 if [ "$NOCVSSPEC" != "yes" ]; then
cd445739 691
049ab214
ER
692 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
693 echo "Warning: No CVS access defined - using local .spec file"
694 NOCVSSPEC="yes"
cd445739
AM
695 fi
696
049ab214 697 cvsup "$SPECFILE" || Exit_error err_no_spec_in_repo
cd445739 698 fi
049ab214 699
cd445739 700 if [ ! -f "$SPECFILE" ]; then
518ff1fb 701 Exit_error err_no_spec_in_repo
cd445739
AM
702 fi
703
704 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
705 chmod $CHMOD_MODE $SPECFILE
706 fi
707 unset OPTIONS
a7eefc54 708 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $SPECFILE
7e40520f 709
ce40491a 710 set_spec_target
cd445739
AM
711}
712
713find_mirror()
714{
01fa66fc 715 cd "$SPEC_DIR"
782518da 716 local url="$1"
cd445739
AM
717 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
718 cvs update mirrors >&2
719 fi
720
721 IFS="|"
782518da
ER
722 local origin mirror name rest ol prefix
723 while read origin mirror name rest; do
724 # skip comments and empty lines
725 if [ -z "$origin" ] || [[ $origin == \#* ]]; then
726 continue
727 fi
a8c9a155
ER
728 ol=$(echo -n "$origin" | wc -c)
729 prefix=$(echo -n "$url" | head -c $ol)
cd445739 730 if [ "$prefix" = "$origin" ] ; then
a8c9a155 731 suffix=$(echo "$url" | cut -b $((ol+1))-)
cd445739
AM
732 echo -n "$mirror$suffix"
733 return 0
734 fi
735 done < mirrors
736 echo "$url"
737}
738
e7e0d4ec 739# Warning: unpredictable results if same URL used twice
cd445739
AM
740src_no ()
741{
01fa66fc 742 cd $SPEC_DIR
cd445739
AM
743 rpm_dump | \
744 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
745 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
746 head -n 1 | xargs
1471f6d6 747}
748
e7e0d4ec 749src_md5()
8ba5cdda 750{
e7e0d4ec 751 [ "$NO5" = "yes" ] && return
cd445739
AM
752 no=$(src_no "$1")
753 [ -z "$no" ] && return
01fa66fc 754 cd $SPEC_DIR
e7e0d4ec
ER
755 local md5
756
757 if [ -f additional-md5sums ]; then
758 local spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
759 if [ -z "$spec_rev" ]; then
a8c9a155 760 spec_rev=$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')
e7e0d4ec
ER
761 fi
762 local spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
763 md5=$(grep -s -v '^#' additional-md5sums | \
764 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
765 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
766 grep -E '^[0-9a-f]{32}$')
767
768 if [ "$md5" ]; then
769 if [ $(echo "$md5" | wc -l) != 1 ] ; then
770 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
771 fi
772 echo "$md5" | tail -n 1
773 return
774 fi
cd445739 775 fi
e7e0d4ec
ER
776
777 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
778 if [ -n "$source_md5" ]; then
779 echo $source_md5
cd445739 780 else
7805dcb4
PZ
781 source_md5=`grep -i "BuildRequires:[ ]*digest(%SOURCE$no)[ ]*=" $SPECFILE | sed -e 's/.*=//'`
782 if [ -n "$source_md5" ]; then
783 echo $source_md5
784 else
785 # we have empty SourceX-md5, but it is still possible
786 # that we have NoSourceX-md5 AND NoSource: X
787 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
788 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
789 echo $nosource_md5
790 fi
cd445739 791 fi
cd445739
AM
792 fi
793}
794
06541433
JR
795distfiles_path ()
796{
797 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
798}
799
cd445739
AM
800distfiles_url ()
801{
06541433 802 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
cd445739
AM
803}
804
805distfiles_attic_url ()
806{
06541433 807 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
cd445739
AM
808}
809
810good_md5 ()
811{
812 md5=$(src_md5 "$1")
813 [ "$md5" = "" ] || \
814 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
815}
816
a4b50627
AF
817good_size ()
818{
a8c9a155 819 size=$(find $(nourl "$1") -printf "%s" 2>/dev/null)
ce40491a 820 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
821}
822
947025e5 823cvsignore_df ()
824{
825 if [ "$CVSIGNORE_DF" != "yes" ]; then
826 return
827 fi
828 cvsignore=${SOURCE_DIR}/.cvsignore
829 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
830 echo "$1" >> $cvsignore
831 fi
832}
833
e7fa3b9f
ER
834cvsup()
835{
ce40491a
ER
836 update_shell_title "cvsup"
837 local OPTIONS="up "
838 if [ -n "$CVSROOT" ]; then
839 OPTIONS="-d $CVSROOT $OPTIONS"
840 fi
b1c6aace 841
ce40491a
ER
842 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
843 OPTIONS="$OPTIONS -A"
844 else
845 if [ -n "$CVSDATE" ]; then
846 OPTIONS="$OPTIONS -D $CVSDATE"
847 fi
848 if [ -n "$CVSTAG" ]; then
849 OPTIONS="$OPTIONS -r $CVSTAG"
850 fi
851 fi
e7fa3b9f 852
ce40491a
ER
853 local result=1
854 local retries_counter=0
855 if [ $# = 1 ]; then
856 update_shell_title "cvsup: $*"
857 else
858 update_shell_title "cvsup: $# files"
859 fi
860 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
861 retries_counter=$(( $retries_counter + 1 ))
862 output=$(LC_ALL=C cvs $OPTIONS "$@" 2>&1)
863 result=$?
864 [ -n "$output" ] && echo "$output"
865 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
866 echo "Trying again [$*]... ($retries_counter)"
867 update_shell_title "cvsup: retry #$retries_counter"
868 sleep 2
869 continue
870 else
871 break
872 fi
873 done
874 update_shell_title "cvsup: done!"
875 return $result
e7fa3b9f
ER
876}
877
71f8e908
ER
878# returns true if "$1" is ftp, http or https protocol url
879is_url()
880{
881 case "$1" in
882 ftp://*|http://*|https://*)
883 return 0
884 ;;
885 esac
886 return 1
887}
888
ecba6ad5
ER
889update_md5()
890{
891 if [ $# -eq 0 ]; then
892 return
893 fi
894
895 update_shell_title "update md5"
896 if [ -n "$DEBUG" ]; then
518ff1fb
ER
897 set -x
898 set -v
ecba6ad5
ER
899 fi
900
901 cd "$SOURCE_DIR"
902
903 # pass 1: check files to be fetched
904 local todo
905 local need_files
906 for i in "$@"; do
907 local fp=$(nourl "$i")
908 local srcno=$(src_no "$i")
6392b5fd
ER
909 if [ -n "$ADD5" ]; then
910 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
01fa66fc 911 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPEC_DIR/$SPECFILE && continue
6c1b2e7d 912 grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $SPEC_DIR/$SPECFILE && continue
6392b5fd 913 else
6c1b2e7d 914 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $SPEC_DIR/$SPECFILE || grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $SPEC_DIR/$SPECFILE || continue
ecba6ad5
ER
915 fi
916 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
917 need_files="$need_files $i"
918 fi
919 done
920
921 # pass 1a: get needed files
922 if [ "$need_files" ]; then
923 get_files $need_files
924 fi
925
926 # pass 2: proceed with md5 adding or updating
927 for i in "$@"; do
928 local fp=$(nourl "$i")
929 local srcno=$(src_no "$i")
01fa66fc 930 local md5=$(grep -iE '^#[ ]*(No)?Source'$srcno'-md5[ ]*:' $SPEC_DIR/$SPECFILE )
e19ad799 931 if [ -z "$md5" ]; then
6c1b2e7d
PZ
932 md5=$(grep -iE '^[ ]*BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $SPEC_DIR/$SPECFILE )
933 fi
71f8e908 934 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
6c1b2e7d 935 local tag="# Source$srcno-md5:\t"
71f8e908 936 if [[ "$md5" == *NoSource* ]]; then
6c1b2e7d
PZ
937 tag="# NoSource$srcno-md5:\t"
938 elif [ -n "$USEDIGEST" ]; then
939 tag="BuildRequires:\tdigest(%SOURCE$srcno) = "
71f8e908 940 fi
ecba6ad5 941 md5=$(md5sum "$fp" | cut -f1 -d' ')
15bf3e99 942 echo "Updating Source$srcno ($md5: $fp)."
ecba6ad5 943 perl -i -ne '
6c1b2e7d
PZ
944 print unless (/^\s*#\s*(No)?Source'$srcno'-md5\s*:/i or /^\s*BuildRequires:\s*digest\(%SOURCE'$srcno'\)/i);
945 print "'"$tag$md5"'\n" if /^Source'$srcno'\s*:\s+/;
ecba6ad5 946 ' \
01fa66fc 947 $SPEC_DIR/$SPECFILE
ecba6ad5
ER
948 fi
949 done
950}
951
952check_md5()
953{
3fbff8b8
ER
954 [ "$NO5" = "yes" ] && return
955
ecba6ad5
ER
956 update_shell_title "check md5"
957
958 for i in "$@"; do
959 if good_md5 "$i" && good_size "$i"; then
960 continue
961 fi
962
963 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
964 echo "or -5 to update md5 sums, if you're sure files are correct."
965 Exit_error err_no_source_in_repo $i
966 done
967}
968
cd445739
AM
969get_files()
970{
7cb24972 971 update_shell_title "get_files"
cd445739
AM
972
973 if [ -n "$DEBUG" ]; then
518ff1fb
ER
974 set -x
975 set -v
cd445739
AM
976 fi
977
f09c0772 978 if [ $# -gt 0 ]; then
cd445739
AM
979 cd "$SOURCE_DIR"
980
b1c6aace 981 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
049ab214 982 echo "Warning: No CVS access defined for SOURCES"
b1c6aace
ER
983 NOCVS="yes"
984 fi
985
f2e42a41 986 local nc=0
e7fa3b9f 987 local get_files_cvs=""
3815b69a 988 for i in "$@"; do
f2e42a41 989 nc=$((nc + 1))
dcebdffb 990 local cvsup=0
3815b69a 991 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 992 update_shell_title "$i"
f09c0772 993 local fp=`nourl "$i"`
ecba6ad5 994 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
ce40491a 995 continue
18e5347d 996 fi
ecba6ad5 997
cd445739 998 FROM_DISTFILES=0
e7e0d4ec 999 local srcmd5=$(src_md5 "$i")
ecba6ad5
ER
1000
1001 # we know if source/patch is present in cvs/distfiles
1002 # - has md5 (in distfiles)
1003 # - in cvs... ideas?
1004
1005 # CHECK: local file didn't exist or always cvs up (first) requested.
f09c0772 1006 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
1007 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
1008 echo "Warning: no URL given for $i"
1009 fi
1010
e7e0d4ec 1011 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
a4b50627 1012 if good_md5 "$i" && good_size "$i"; then
e7e0d4ec 1013 echo "$fp having proper md5sum already exists"
cd445739
AM
1014 continue
1015 fi
4ea1c265 1016 target="$fp"
28b34560 1017
bc10f694 1018 # optionally prefer mirror over distfiles if there's mirror
28b34560 1019 # TODO: build url list and then try each url from the list
bc10f694 1020 if [ -n "$PREFMIRRORS" ] && [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
28b34560
ER
1021 url="$im"
1022 else
1023 url=$(distfiles_url "$i")
1024 fi
1025
cd445739
AM
1026 url_attic=$(distfiles_attic_url "$i")
1027 FROM_DISTFILES=1
ecba6ad5
ER
1028 # is $url local file?
1029 if [[ "$url" = [./]* ]]; then
18a52930 1030 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
1031 ${GETLOCAL} $url $target
1032 else
1033 if [ -z "$NOMIRRORS" ]; then
9e9f8920 1034 url=$(find_mirror "$url")
cd445739 1035 fi
9e9f8920
ER
1036
1037 local uri=${url}
1038 # make shorter message for distfiles urls
1039 if [[ "$uri" = ${PROTOCOL}${DISTFILES_SERVER}* ]] || [[ "$uri" = ${PROTOCOL}${ATTICDISTFILES_SERVER}* ]]; then
1040 uri=${uri#${PROTOCOL}${DISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1041 uri=${uri#${PROTOCOL}${ATTICDISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1042 uri="df: $uri"
1043 fi
1044 update_shell_title "${GETURI%% *}: $uri"
ca2e6c31 1045 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1046 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 1047 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1048 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
1049 fi
1050 fi
ecba6ad5
ER
1051
1052 # is it empty file?
1053 if [ ! -s "$target" ]; then
cd445739
AM
1054 rm -f "$target"
1055 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 1056 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
1057 ${GETLOCAL} $url_attic $target
1058 else
1059 if [ -z "$NOMIRRORS" ]; then
a8c9a155 1060 url_attic=$(find_mirror "$url_attic")
cd445739 1061 fi
18a52930 1062 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1063 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1064 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1065 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1066 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
1067 fi
1068 fi
1069 fi
ecba6ad5
ER
1070
1071 if [ -s "$target" ]; then
947025e5 1072 cvsignore_df $target
1073 else
cd445739
AM
1074 rm -f "$target"
1075 FROM_DISTFILES=0
1076 fi
e7e0d4ec 1077 elif [ "$NOCVS" != "yes" -a -z "$srcmd5" ]; then
d05e8080
ER
1078 if [ $# -gt 1 ]; then
1079 get_files_cvs="$get_files_cvs $fp"
1080 update_shell_title "$fp (will cvs up later)"
1081 cvsup=1
1082 else
1083 cvsup $fp
1084 fi
cd445739
AM
1085 fi
1086
f09c0772 1087 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739 1088 if [ -z "$NOMIRRORS" ]; then
a8c9a155 1089 im=$(find_mirror "$i")
cd445739
AM
1090 else
1091 im="$i"
1092 fi
ce40491a 1093 update_shell_title "${GETURI%% *}: $im"
cd445739 1094 ${GETURI} "$im" || \
33da77c4 1095 if [ "`echo $im | grep -E 'ftp://'`" ]; then
ce40491a 1096 update_shell_title "${GETURI2%% *}: $im"
cd445739 1097 ${GETURI2} "$im"
7e365483 1098 fi
cd445739
AM
1099 fi
1100
dcebdffb
ER
1101 if [ "$cvsup" = 1 ]; then
1102 continue
1103 fi
1104
cd445739 1105 fi
ecba6ad5
ER
1106
1107 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
f09c0772 1108 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
cdbd30e8 1109 if [ -n "GREEDSRC" ]; then
1110 get_greed_sources $i
1111 else
1112 Exit_error err_no_source_in_repo $i
1113 fi
cd445739 1114 fi
2a5f078d 1115
ecba6ad5 1116 # we check md5 here just only to refetch immediately
a4b50627 1117 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
1118 :
1119 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 1120 # wrong md5 from distfiles: remove the file and try again
cd445739 1121 # but only once ...
deccc50e 1122 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
1123 FROM_DISTFILES=2
1124 rm -f $target
18a52930 1125 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 1126 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1127 if [ "`echo $url | grep -E 'ftp://'`" ]; then
ce40491a 1128 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1129 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739 1130 fi
ecba6ad5 1131 if [ ! -s "$target" ]; then
cd445739 1132 rm -f "$target"
18a52930 1133 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1134 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1135 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1136 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1137 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
1138 fi
1139 fi
1140 test -s "$target" || rm -f "$target"
1141 fi
cd445739 1142 done
e7fa3b9f
ER
1143 SHELL_TITLE_PREFIX=""
1144
1145 if [ "$get_files_cvs" ]; then
ce40491a 1146 cvsup $get_files_cvs
e7fa3b9f 1147 fi
cd445739
AM
1148
1149 if [ "$CHMOD" = "yes" ]; then
a8c9a155 1150 CHMOD_FILES=$(nourl "$@")
cd445739
AM
1151 if [ -n "$CHMOD_FILES" ]; then
1152 chmod $CHMOD_MODE $CHMOD_FILES
1153 fi
1154 fi
cd445739
AM
1155 fi
1156}
1157
1158make_tagver() {
ce40491a 1159 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1160 set -x
1161 set -v
ce40491a 1162 fi
78eab2a1 1163
ce40491a
ER
1164 # Check whether first character of PACKAGE_NAME is legal for tag name
1165 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1166 TAG_PREFIX=tag_
1167 fi
d712cc12
ER
1168
1169 # NOTE: CVS tags may must not contain the characters `$,.:;@'
392187d9 1170 TAGVER=$(echo $TAG_PREFIX$PACKAGE_NAME-$PACKAGE_VERSION-$PACKAGE_RELEASE | tr '[.@]' '[_#]')
d712cc12 1171
ce40491a
ER
1172 # Remove #kernel.version_release from TAGVER because tagging sources
1173 # could occur with different kernel-headers than kernel-headers used at build time.
d712cc12
ER
1174 # besides, %{_kernel_ver_str} is not expanded.
1175
1176 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1#%{_kernel_ver_str}
1177 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1
1178
1179 TAGVER=${TAGVER%#*}
ce40491a 1180 echo -n "$TAGVER"
cd445739
AM
1181}
1182
c713aac3
AG
1183# bool is_tag_a_branch(tag)
1184#
1185# returns 1 if a tag is a branch set on SPECFILE
1186is_tag_a_branch() {
1187 if [ -n "$DEBUG" ]; then
1188 set -x
1189 set -v
1190 fi
1191
1192 if [ $# -ne 1 ]; then
1193 return 0;
1194 fi
1195
1196 TAG=$1
f5141bbc 1197
c713aac3
AG
1198 cd "$SPEC_DIR"
1199 cvs status -v $SPECFILE | grep -Eiq "${TAG}.+(branch: [0-9.]+)"
1200 return $?
1201}
1202
cd445739
AM
1203tag_files()
1204{
1205 TAG_FILES="$@"
1206
1207 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1208 set -x
1209 set -v
cd445739
AM
1210 fi
1211
73ef63d8
ER
1212 echo "Version: $PACKAGE_VERSION"
1213 echo "Release: $PACKAGE_RELEASE"
cd445739 1214
a18a9761 1215 local TAGVER
73ef63d8 1216 if [ "$TAG_VERSION" = "yes" ]; then
a18a9761 1217 TAGVER=`make_tagver`
73ef63d8
ER
1218 echo "CVS tag: $TAGVER"
1219 fi
1220 if [ -n "$TAG" ]; then
1221 echo "CVS tag: $TAG"
1222 fi
cd445739 1223
39dcc7de 1224 local OPTIONS="tag $CVS_FORCE"
73ef63d8
ER
1225 if [ -n "$CVSROOT" ]; then
1226 OPTIONS="-d $CVSROOT $OPTIONS"
1227 fi
cd445739 1228
c713aac3
AG
1229 # if a tagname we are about to set already exists
1230 # and happens to be a branch (common case with AC-branch)
1231 # pass -B (allows -F to disturb branch tag)
1232 local _tag=$TAG
1233 if [ "$TAG_VERSION" = "yes" ]; then
1234 _tag=$TAGVER
1235 fi;
1236 is_tag_a_branch $_tag
28c23a72 1237 if [ $? -eq 0 -a $CVS_NSERVER -eq 0 ]; then
c713aac3
AG
1238 OPTIONS="$OPTIONS -B"
1239 fi;
1240
73ef63d8
ER
1241 cd "$SOURCE_DIR"
1242 local tag_files
1243 for i in $TAG_FILES; do
1244 # don't tag files stored on distfiles
1245 [ -n "`src_md5 $i`" ] && continue
1246 local fp=`nourl "$i"`
1247 if [ -f "$fp" ]; then
1248 tag_files="$tag_files $fp"
cdbd30e8 1249 elif [ -n "GREEDSRC" ]; then
1250 get_greed_sources $i
73ef63d8
ER
1251 else
1252 Exit_error err_no_source_in_repo $i
03db3356 1253 fi
73ef63d8 1254 done
03db3356 1255
73ef63d8 1256 if [ "$tag_files" ]; then
cd445739 1257 if [ "$TAG_VERSION" = "yes" ]; then
73ef63d8 1258 update_shell_title "tag sources: $TAGVER"
19ca62ef 1259 printf "Tagging %d files\n" $(echo $tag_files | wc -w)
c7e6ee9b 1260 cvs $OPTIONS $TAGVER $tag_files || exit
cd445739
AM
1261 fi
1262 if [ -n "$TAG" ]; then
73ef63d8 1263 update_shell_title "tag sources: $TAG"
c4ff623e
ER
1264
1265 while [ "$tag_files" ]; do
1266 local chunk=$(echo $tag_files | tr ' ' '\n' | head -n 100)
1267 printf "Tagging %d files\n" $(echo $chunk | wc -w)
1268 cvs $OPTIONS $TAG $chunk || exit
1269 tag_files=$(echo $tag_files | tr ' ' '\n' | tail +101)
1270 done
cd445739 1271 fi
73ef63d8
ER
1272 fi
1273
01fa66fc 1274 cd "$SPEC_DIR"
73ef63d8
ER
1275 if [ "$TAG_VERSION" = "yes" ]; then
1276 update_shell_title "tag spec: $TAGVER"
c7e6ee9b 1277 cvs $OPTIONS $TAGVER $SPECFILE || exit
73ef63d8
ER
1278 fi
1279 if [ -n "$TAG" ]; then
1280 update_shell_title "tag spec: $TAG"
c7e6ee9b 1281 cvs $OPTIONS $TAG $SPECFILE || exit
73ef63d8 1282 fi
cd445739
AM
1283}
1284
1285branch_files()
1286{
1287 TAG=$1
1288 echo "CVS branch tag: $TAG"
518ff1fb 1289 shift
cd445739
AM
1290
1291 TAG_FILES="$@"
1292
1293 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1294 set -x
1295 set -v
cd445739
AM
1296 fi
1297
78a5a506 1298 local OPTIONS="tag $CVS_FORCE -b"
ec6b5dfc
AG
1299
1300 # branch exists?
1301 is_tag_a_branch $TAG
1302 if [ $? -eq 1 ]; then
1303 OPTIONS="$OPTIONS -B"
1304 fi
1305
78a5a506
ER
1306 if [ -n "$CVSROOT" ]; then
1307 OPTIONS="-d $CVSROOT $OPTIONS"
1308 fi
1309 cd "$SOURCE_DIR"
1310 local tag_files
1311 for i in $TAG_FILES; do
1312 local fp=`nourl "$i"`
1313 if [ -f "$fp" ]; then
1314 tag_files="$tag_files $fp"
cdbd30e8 1315 elif [ -n "GREEDSRC" ]; then
1316 get_greed_sources $i
78a5a506
ER
1317 else
1318 Exit_error err_no_source_in_repo $i
c10fa4fa 1319 fi
78a5a506
ER
1320 done
1321 if [ "$tag_files" ]; then
c7e6ee9b 1322 cvs $OPTIONS $TAG $tag_files || exit
78a5a506 1323 fi
c10fa4fa 1324
01fa66fc 1325 cd "$SPEC_DIR"
c7e6ee9b 1326 cvs $OPTIONS $TAG $SPECFILE || exit
cd445739
AM
1327}
1328
1329
3009b80d
ER
1330# this function should exit early if package can't be built for this arch
1331# this avoids unneccessary BR filling.
1332check_buildarch() {
1333 local out ret
13c3c336 1334 out=$(minirpm --short-circuit -bp --define "'prep exit 0'" --nodeps $SPECFILE 2>&1)
3009b80d
ER
1335 ret=$?
1336 if [ $ret -ne 0 ]; then
1337 echo >&2 "$out"
1338 exit $ret
1339 fi
1340}
1341
cd445739 1342
59398507 1343build_package()
1344{
2e5be021 1345 update_shell_title "build_package"
cd445739 1346 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1347 set -x
1348 set -v
cd445739 1349 fi
5a491465 1350
01fa66fc 1351 cd "$SPEC_DIR"
cd445739
AM
1352
1353 if [ -n "$TRY_UPGRADE" ]; then
ce40491a 1354 update_shell_title "build_package: try_upgrade"
cd445739 1355 if [ -n "$FLOAT_VERSION" ]; then
45e2a818 1356 TNOTIFY=$(./pldnotify.awk $SPECFILE -n) || exit 1
cd445739 1357 else
45e2a818 1358 TNOTIFY=$(./pldnotify.awk $SPECFILE) || exit 1
cd445739
AM
1359 fi
1360
45e2a818 1361 TNEWVER=$(echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }')
cd445739
AM
1362
1363 if [ -n "$TNEWVER" ]; then
1364 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
1365 echo "New version found, updating spec file to version " $TNEWVER
257af81b
ER
1366 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1367 cp -f $SPECFILE $SPECFILE.bak
1368 fi
cd445739
AM
1369 chmod +w $SPECFILE
1370 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
f7b91886 1371 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
518ff1fb
ER
1372 parse_spec
1373 NODIST="yes" get_files $SOURCES $PATCHES
6392b5fd 1374 update_md5 $SOURCES
975d7b23 1375
cd445739
AM
1376 unset TOLDVER TNEWVER TNOTIFY
1377 fi
1378 fi
01fa66fc 1379 cd "$SPEC_DIR"
2a5f078d 1380
cd445739
AM
1381 case "$COMMAND" in
1382 build )
1383 BUILD_SWITCH="-ba" ;;
1384 build-binary )
1385 BUILD_SWITCH="-bb" ;;
1386 build-source )
1387 BUILD_SWITCH="-bs --nodeps" ;;
1388 build-prep )
1389 BUILD_SWITCH="-bp --nodeps" ;;
6594293d
AG
1390 build-build )
1391 BUILD_SWITCH="-bc" ;;
1392 build-install )
1393 BUILD_SWITCH="-bi" ;;
1394 build-list )
1395 BUILD_SWITCH="-bl" ;;
1396
cd445739 1397 esac
c890b916 1398
2e5be021 1399 update_shell_title "build_package: $COMMAND"
cd445739
AM
1400 if [ -n "$LOGFILE" ]; then
1401 LOG=`eval echo $LOGFILE`
1402 if [ -d "$LOG" ]; then
1403 echo "Log file $LOG is a directory."
1404 echo "Parse error in the spec?"
518ff1fb 1405 Exit_error err_build_fail
cd445739
AM
1406 fi
1407 if [ -n "$LASTLOG_FILE" ]; then
1408 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1409 fi
525bf240
ER
1410 RES_FILE=$(mktemp -t builder.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM)
1411
fff1b991 1412 (time eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
1413 RETVAL=`cat $RES_FILE`
1414 rm $RES_FILE
1415 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1416 if [ "$RETVAL" -eq "0" ]; then
1417 mv $LOG $LOGDIROK
1418 else
1419 mv $LOG $LOGDIRFAIL
1420 fi
1421 fi
8ba5cdda 1422 else
fff1b991 1423 eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND $SPECFILE
cd445739 1424 RETVAL=$?
8ba5cdda 1425 fi
cd445739
AM
1426 if [ "$RETVAL" -ne "0" ]; then
1427 if [ -n "$TRY_UPGRADE" ]; then
796a8a95 1428 echo "\n!!! Package with new version cannot be built automagically\n"
257af81b
ER
1429 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1430 mv -f $SPECFILE.bak $SPECFILE
1431 fi
cd445739 1432 fi
518ff1fb 1433 Exit_error err_build_fail
cd445739
AM
1434 fi
1435 unset BUILD_SWITCH
1436}
1437
1438nourl()
1439{
1440 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1441}
1442
cd445739
AM
1443install_required_packages()
1444{
1445 run_poldek -vi $1
1446 return $?
1447}
1448
fa4bf1df
ER
1449find_spec_bcond() {
1450 # taken from find-spec-bcond, but with just getting the list
1451 local SPEC="$1"
fa4bf1df
ER
1452 awk -F"\n" '
1453 /^%changelog/ { exit }
1454 /_with(out)?_[_a-zA-Z0-9]+/{
1455 match($0, /_with(out)?_[_a-zA-Z0-9]+/);
1456 print substr($0, RSTART, RLENGTH);
1457 }
1458 /^%bcond_with/{
1459 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
1460 bcond = substr($0, RSTART +5 , RLENGTH -5);
1461 gsub(/[ \t]+/,"_",bcond);
1462 print bcond
1463 }' $SPEC | LC_ALL=C sort -u
1464}
1465
117d9861 1466process_bcondrc() {
301cbfd4
ER
1467 # expand bconds from ~/.bcondrc
1468 # The file structure is like gentoo's package.use:
1469 # ---
1470 # * -selinux
1471 # samba -mysql -pgsql
47a8df12 1472 # w32codec-installer license_agreement
301cbfd4
ER
1473 # php +mysqli
1474 # ---
fa4bf1df 1475 if ([ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ])); then
117d9861
ER
1476 :
1477 else
1478 return
1479 fi
301cbfd4 1480
117d9861 1481 SN=${SPECFILE%%\.spec}
c8a3e2ac 1482
117d9861
ER
1483 local bcondrc=$HOME/.bcondrc
1484 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
301cbfd4 1485
117d9861 1486 local bcond_avail=$(find_spec_bcond $SPECFILE)
301cbfd4 1487
117d9861
ER
1488 while read pkg flags; do
1489 # ignore comments
1490 [[ "$pkg" == \#* ]] && continue
1491
1492 # any package or current package?
1493 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1494 for flag in $flags; do
1495 local opt=${flag#[+-]}
1496
1497 # use only flags which are in this package.
1498 if [[ $bcond_avail = *${opt}* ]]; then
1499 if [[ $flag = -* ]]; then
1500 if [[ $BCOND != *--with?${opt}* ]]; then
1501 BCOND="$BCOND --without $opt"
1502 fi
1503 else
1504 if [[ $BCOND != *--without?${opt}* ]]; then
1505 BCOND="$BCOND --with $opt"
301cbfd4
ER
1506 fi
1507 fi
117d9861
ER
1508 fi
1509 done
1510 fi
1511 done < $bcondrc
1512 update_shell_title "parse ~/.bcondrc: DONE!"
1513}
1514
1515set_bconds_values()
1516{
1517 update_shell_title "set bcond values"
1518
1519 AVAIL_BCONDS_WITHOUT=""
1520 AVAIL_BCONDS_WITH=""
1521 if `grep -q ^%bcond ${SPECFILE}`; then
1522 BCOND_VERSION="NEW"
1523 elif `egrep -q ^#\ *_with ${SPECFILE}`; then
1524 BCOND_VERSION="OLD"
1525 else
1526 return
301cbfd4
ER
1527 fi
1528
117d9861
ER
1529 local bcond_avail=$(find_spec_bcond $SPECFILE)
1530 process_bcondrc "$SPECFILE"
1531
fa4bf1df 1532 update_shell_title "parse bconds"
cd445739 1533 case "${BCOND_VERSION}" in
fa4bf1df 1534 NONE)
7e365483 1535 :
cd445739 1536 ;;
7e365483 1537 OLD)
cd445739 1538 echo "Warning: This spec has old style bconds. Fix it || die."
fa4bf1df 1539 for opt in `echo "$bcond_avail" | grep ^_without_`
cd445739 1540 do
fa4bf1df
ER
1541 AVAIL_BCOND_WITHOUT=${opt#_without_}
1542 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1543 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1544 else
1545 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1546 fi
1547 done
2a5f078d 1548
fa4bf1df 1549 for opt in `echo "$bcond_avail" | grep ^_with_`
cd445739 1550 do
fa4bf1df
ER
1551 AVAIL_BCOND_WITH=${opt#_with_}
1552 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1553 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1554 else
1555 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1556 fi
1557 done
1558 ;;
1559 NEW)
fa4bf1df
ER
1560 local cond_type="" # with || without
1561 for opt in $bcond_avail; do
cd445739
AM
1562 case "$opt" in
1563 _without)
1564 cond_type="without"
1565 ;;
1566 _with)
1567 cond_type="with"
1568 ;;
f8d24cee 1569 _without_*)
fa4bf1df
ER
1570 AVAIL_BCOND_WITHOUT=${opt#_without_}
1571 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
f8d24cee 1572 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1573 else
1574 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1575 fi
1576 ;;
1577 _with_*)
fa4bf1df
ER
1578 AVAIL_BCOND_WITH=${opt#_with_}
1579 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
f8d24cee 1580 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1581 else
1582 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1583 fi
1584 ;;
cd445739
AM
1585 *)
1586 case "$cond_type" in
1587 with)
1588 cond_type=''
1589 AVAIL_BCOND_WITH="$opt"
fa4bf1df 1590 if [[ "$BCOND" = *--with?${AVAIL_BCOND_WITH}* ]]; then
cd445739
AM
1591 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1592 else
1593 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1594 fi
7e365483 1595 ;;
cd445739
AM
1596 without)
1597 cond_type=''
1598 AVAIL_BCOND_WITHOUT="$opt"
fa4bf1df 1599 if [[ "$BCOND" = *--without?${AVAIL_BCOND_WITHOUT}* ]]; then
cd445739
AM
1600 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1601 else
1602 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1603 fi
1604 ;;
1605 esac
1606 ;;
1607 esac
1608 done
1609 ;;
1610 esac
1611}
1612
1613run_sub_builder()
1614{
1615 package_name="${1}"
af6b168f 1616 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1617 #
1618